import { JscTarget } from '@swc/types';
import { OutputOptions } from 'rollup';

type ExportCondition = string | {
    [key: string]: ExportCondition | string;
};
type BundleConfig = {
    file?: string;
    cwd?: string;
    watch?: boolean;
    target?: JscTarget;
    format?: OutputOptions['format'];
    minify?: boolean;
    sourcemap?: boolean;
    external?: string[] | null;
    env?: string[];
    dts?: boolean;
    runtime?: string;
    pkg?: PackageMetadata;
    clean?: boolean;
    tsconfig?: string;
};
type PackageMetadata = {
    name?: string;
    main?: string;
    bin?: string | Record<string, string>;
    module?: string;
    type?: 'commonjs' | 'module';
    dependencies?: Record<string, string>;
    peerDependencies?: Record<string, string>;
    peerDependenciesMeta?: Record<string, Record<string, string>>;
    exports?: string | Record<string, ExportCondition>;
    types?: string;
    typings?: string;
};

declare function bundle(cliEntryPath: string, { cwd: _cwd, ...options }?: BundleConfig): Promise<any>;

export { type BundleConfig, bundle };
